exports.CorpusCPS = CorpusCPS

var ERROR = require("./error.js")
var RV = require("./rendez_vous.js")
var SQLITE = require("sqlite3")
var FS = require("fs")
var GIT = require("./git.js")
var UTIL = require("./util.js")
var mine_db = new SQLITE.Database("mine.db")

function CorpusCPS (k, h) {
  h = ERROR.chain(h, "corpus_cps")
  var root = "/Users/soft/Desktop/selenium_experiment/workspace/repos"
  FS.readdir(root, ERROR.maybe(function (owners) {
    UTIL.remove(".DS_Store", owners)
    var repos = {}
    var rendez_vous = RV.RendezVous(owners.length, function () { k(repos) }, ERROR.chain(h, "reading owner"))
    owners.forEach(function (owner) {
      FS.readdir(root + "/" + owner, ERROR.maybe(function (names) {
        UTIL.remove(".DS_Store", names)
        function loop (i) {
          var name = names[i]
          if (i < names.length) {
            GIT.RepositoryCPS(root + "/" + owner + "/" + name, function (repo) {
              repos[owner + "/" + name] = repo
              loop(i+1)
            }, ERROR.chain(rendez_vous.no, "error while loading git: " + owner + "/" + name))
          } else {
            rendez_vous.yes()
          }
        }
        loop(0)
      }, ERROR.chain(h, "cant read owner " + owner)))
    })
  }, ERROR.chain(h, "cant read corpus " + root)))
}