exports.maybe = maybe
exports.signal = signal
exports.Signal = Signal
exports.chain = chain

function maybe (k, h) {
  return function (_error, _x) {
    if (_error) {
      h(_error)
    } else {
      k(_x)
    }
  }
}

function chain (h, msg) {
  return function (error) {
    log(error, msg)
    h(error)
  }
}

function log (error, msg) {
  if (error.logs) {
    error.logs.push(msg)
  } else {
    error.logs = [msg]
  }
}

function Signal (msg) {
  return function (error) {
    log(error, msg)
    signal(error)
  }
}

function signal (error) {
  console.log(error.message)
  console.log(error.stack)
  if (error.logs) {
    console.log(error.logs.join("\n"))
  }
  process.exit(1)
}