exports.padding = padding
exports.compose = compose                 
exports.last = last
exports.remove = remove
exports.each = each
exports.check_java_selenium = check_java_selenium
exports.merge = merge
exports.merge_into = merge_into

var tab_size = 4
function padding(depth) { return new Array((tab_size*depth)+1).join(" ") }

function compose (f, g) {
  return function (x) {
    return f(g(x))
  }
}

function last (xs) {
  return xs[xs.length - 1]
}

function remove (x, xs) {
  var i = xs.indexOf(x)
  if (i != -1) {
    xs.splice(i, 1)
  }
}

function merge_into (o1, o2) {
  for (k in o1) {
    o2[k] = o1[k]
  }
}

function merge_all (os) {
  var o = {}
  for (i in os) {
    for (k in os[i]) {
      o[k] = os[i][k]
    }
  }
  return o
}

function merge (o1, o2) {
  var o = {}
  for (k1 in o1) {
    o[k1] = o1[k1] 
  }
  for (k2 in o2) {
    o[k2] = o2[k2]
  }
  return o
}

function each (o, f) {
  var keys = Object.keys(o)
  for (var i = 0; i < keys.length ; i++) {
    f(keys[i], o[keys[i]])
  }
}

function proper_java (code) {
  return code.replace(/\/\*([^*]|\*(?!\/))*\*\//g, "").replace(/\n(\ |\t)*\n/g, "\n")
}

function check_java_selenium (code) {
  return code.match(/import\ [^;]*\.selenium\.[^;]*;/g)
}